#include <stdio.h>
#include <math.h>
#include <image.h>
#include <string.h>
#include <hist.h>

int main () {

int i,j,g, dim_x, dim_y, max;
double H0_1=0.0, H0_2=0.0, p_i=0.0, komp_max_1=0.0, komp_max_2=0.0;
Hist histo1,histo2;
Image bild,leerbild,transbild,rekonbild;
string dateiname;

//Abfrage der Datei
 cout <<"BILD-Komprimator\n\nWelches Bild soll kleingeklopft werden?"<<endl;
 cin>>dateiname;

//Zuweisung von Breite und Hhe und Laden des input-Bildes
InfImgFile(dateiname,dim_x,dim_y,max);

bild=NewImg(dim_x,dim_y,max);
leerbild=NewImg(dim_x,dim_y,max);
transbild=NewImg(dim_x,dim_y,max);
rekonbild=NewImg(dim_x,dim_y,max);

ClearImg(bild);
ClearImg(leerbild);
ClearImg(transbild);
ClearImg(rekonbild);

Display(OFF);

bild=ReadImg(dateiname);

//Histogrammaufruf-Berechnung
histo1=HistImg(bild);

//Entropie des Originalbildes
for (i=0;i<256;i++)
  {
  p_i=histo1.Rel(i);
    if (p_i != 0)
	{
	  H0_1+=(-1)*p_i*log(p_i)/log(2);
	}
    else {continue;};
  }


//Ausgabe
OpenAlpha("Informatikpraktikum Aufgabe 2 - Histogramm");
ClearAlpha();
SetAttribute(0,7,0,0);
Printf("\nDie Entropie des Originalbildes betraegt: %6.3lf", H0_1);

//Transformation von "transbild"
for (i=0;i<dim_x;i++)
for (j=0;j<dim_y;j++)
  {
    if (j!=0) {
   g = (256+GetVal(bild,i,j) - GetVal(bild,i,j-1))%256; //% = mod! 
   PutVal(transbild,i,j,g);
    }
    else {PutVal(transbild,i,j,GetVal(bild,i,j));}
  }

//Histogramm des Transformierten Bildes
histo2=HistImg(transbild);
  
//Entropie des Transformierten Bildes
for (i=0;i<256;i++)
  {
  p_i=histo2.Rel(i);
    if (p_i != 0) {
      H0_2+=(-1)*p_i*log(p_i)/log(2);}
    else {continue;};
  }
  
//Berechnung und Ausgabe der theoretisch erreichbaren verlustfreien Kompression
 komp_max_1 = 100.0 * (8.0-H0_1)/8.0;
 komp_max_2 = 100.0 * (8.0-H0_2)/8.0;
Printf("\nMaximale verlustfreie Kompressionsraten:\nOriginalbild: %6.0lf [Prozent] \nTransformiertes Bild: %6.0lf [Prozent]\n",komp_max_1,komp_max_2);

//Rekonstruktion von Originalbild aus transformiertem Bild
for (i=0;i<dim_x;i++)
for (j=0;j<dim_y;j++)
  {
    if (j != 0) {
    g = (GetVal(transbild,i,j) + GetVal(rekonbild,i,j-1))%256;
    PutVal(rekonbild,i,j,g);
    }
    else {
    PutVal(rekonbild,i,j,GetVal(transbild,i,j));
    }
  }

Display(ON);

 Show(ON,bild);
 histo1.Vis(1,bild);
 GetChar();
 Show(OFF, bild);
 Show(ON,transbild);
 histo2.Vis(256,transbild);
 GetChar();
 Show(OFF, transbild);
 Show(ON,rekonbild);
 GetChar();
 Show(OFF,rekonbild);

 FreeAllImg();
 CloseAlpha();
 Display(OFF);
 

}
